/* 
 * File   : SBCEncoderAbstraction.c
 * Author : Serhiy Tkachenko <Serhiy.Tkachenko@tomtom.com>
 * Rewrite: Koen Martens <Koen.Martens@tomtom.com>
 * Desc.  : C++ like abstraction for TomTom SBC encoder
 *
 * Copyright (C) 2004,2005 TomTom BV <http://www.tomtom.com/>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 */

#include <assert.h>
#include <errno.h>
#include <stdio.h>

#include "DynamicSBC.h"
#include "sbc.h"

#ifdef DEBUG
  #define DBG(fmt, arg...)      fprintf(stderr,"%s: " fmt , __FUNCTION__, ##arg)
#else
  #define DBG(fmt, arg...)      do {} while(0)
#endif

int SBCEncoderInputType( void )
{
 DBG("================= SBC_IN_MAD\n");
 return SBC_IN_MAD;
}

//   iSBCEncoder.iSBCEncode = sbc_encode;
//   iSBCEncoder.iSBCFinish = sbc_finish;
//   iSBCEncoder.iSBCInit   = sbc_init;
//   break;

int SBCInit( sbc_t *sbc, unsigned long flags, int aBitPool )
{
  return sbc_init(sbc,flags,aBitPool);
}

int SBCEncode( sbc_t *sbc, void *data, int count )
{
  return sbc_encode(sbc,data,count);
}

void SBCFinish( sbc_t *sbc )
{
  sbc_finish(sbc);
}
 
