/******************************************************************
 Configuration file for SBC encoder
*/

#ifndef __SBC_CONFIG_H__
#define __SBC_CONFIG_H__

// MAD configuarion part
#ifdef SAMSUNG
#define FPM_ARM
#else
#define FPM_INTEL
#endif

#define OPT_ACCURACY     1

#define SIZEOF_INT       4
#define SIZEOF_LONG      4
#define SIZEOF_LONG_LONG 8

#define HAVE_UNISTD_H 1
#define HAVE_WAITPID  1
#define HAVE_FCNTL    1
#define HAVE_PIPE     1
#define HAVE_FORK     1
#define HAVE_ASSERT_H 1

#include "fixed.h"

// Generic configuration
#define PCM_DOUBLE_SHIFT 16
#define PCM_INT_SHIFT    12

typedef double sbc_fixed_t;

// Extra macros for 64 bit addition and substraction
#define MAD_F_ADD( hires, lores, hi, lo ) \
{ hires += ( hi ); lores += ( lo ); hires += ( ( lores ) < ( lo ) ); } 

#define MAD_F_SUB( hires, lores, hi, lo ) \
{ lores -= ( lo ); hires -= ( hi ); hires -= ( ( lores ) > ( lo ) ); }

/*
#define MAD_F_NEG( hires, lores, hi, lo ) \
{ hires = ~( hi ); lores = ~( lo ); MAD_F_ADD( hires, lores, 0, 1 ); }

#define MAD_F_SUB( hires, lores, hi, lo )   \
{                                           \
  mad_fixed64hi_t nhi;                      \  
  mad_fixed64lo_t nlo;                      \
  MAD_F_NEG( nhi, nlo, hi, lo );            \
  MAD_F_ADD( hires, lores, nhi, nlo );      \
}                                                     
*/

#endif // __SBC_CONFIG_H__
