/**************************************************************
 Generic SBC structures defintion
***************************************************************/

#ifndef __SBCDEF_H__
#define __SBCDEF_H__

#include "SBCConfig.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct  
{
 mad_fixed_t* m_pSamples;
 double*      m_pTestSamples;
 //sbc_fixed_t* m_pHead;
 //sbc_fixed_t* m_pTail;
} SBCSampleList;

// SBC sample list management
SBCSampleList* SBCInitSampleList( int aSampleCount );
void           SBCDoneSampleList( SBCSampleList* aSampleList );
void           SBCReadSamples80( SBCSampleList* aSampleList, mad_fixed_t* aSampleArray );
void           SBCReadSamples40( SBCSampleList* aSampleList, sbc_fixed_t* aSampleArray );

static inline mad_fixed_t SBCPCMToFixed( int aPCMSample )
{
 return ( aPCMSample << PCM_INT_SHIFT );
}

static inline int SBCFixedToPCM( mad_fixed_t aSample )
{
 return ( aSample >> PCM_INT_SHIFT );
}

#ifdef __cplusplus
}
#endif

#endif // __SBCDEF_H__

