/************************************************************************/
/* Generic utilites for SBC                                            */
/************************************************************************/

#include <assert.h>
#include <memory.h>
#include <stdio.h>
#include <malloc.h>

#include "SBCDef.h"

SBCSampleList* SBCInitSampleList( int aSampleCount )
{
 assert( aSampleCount > 0 );

 SBCSampleList* tmpRes = ( SBCSampleList* )malloc( sizeof( SBCSampleList ) );
 assert( NULL != tmpRes );

 memset( tmpRes, 0, sizeof( SBCSampleList ) );
 tmpRes->m_pSamples = ( mad_fixed_t* )malloc( aSampleCount * sizeof( mad_fixed_t ) );
 assert( NULL != tmpRes->m_pSamples );

 /*tmpRes->m_pTestSamples = ( double* )malloc( aSampleCount * sizeof( double ) );
 assert( NULL != tmpRes->m_pTestSamples );*/

 //tmpRes->m_iSize = aSampleCount;

 return tmpRes;
}

void SBCDoneSampleList( SBCSampleList* aSampleList )
{
 assert( NULL != aSampleList );
 assert( NULL != aSampleList->m_pSamples );

 free( aSampleList->m_pSamples );
 //free( aSampleList->m_pTestSamples );
 free( aSampleList );
}

void SBCReadSamples80( 
      SBCSampleList* aSampleList, 
      mad_fixed_t*   aSampleArray )
{
 int i;

 assert( NULL != aSampleList );
 assert( NULL != aSampleArray );

 memmove( aSampleList->m_pSamples + 8, 
          aSampleList->m_pSamples, 
          72 * sizeof( mad_fixed_t ) );

/* memmove( aSampleList->m_pTestSamples + 8, 
          aSampleList->m_pTestSamples, 
          72 * sizeof( double ) );*/

 for( i = 7; i >= 0; i--) 
 {
  aSampleList->m_pSamples[ i ] = aSampleArray[ ( 7 - i ) << 1 ]; 
  //aSampleList->m_pTestSamples[ i ] = aSampleArray[ 7 - i ];

  //fprintf( stderr, "New %lf, Old %lf, %lf\n", mad_f_todouble( aSampleList->m_pSamples[ i ] ), aSampleList->m_pTestSamples[ i ], aSampleArray[ 7 - i ] / ( 1L << 16 ) );
 }
/*
 for( i = 0; i < 80; ++i )
 {
  fprintf( stderr, "%lf ", mad_f_todouble( aSampleList->m_pSamples[ i ] ) );
 }
 fprintf( stderr, "\n" ); 
 for( i = 0; i < 80; ++i )
 {
  fprintf( stderr, "%lf ", aSampleList->m_pTestSamples[ i ] / ( 1L << 16 ) );
 }
 fprintf( stderr, "\n\n" ); */
}

void SBCReadSamples40( SBCSampleList* aSampleList, sbc_fixed_t* aSampleArray )
{
 assert( NULL != aSampleList );
 assert( NULL != aSampleArray );

 assert( 0 ); // Not implemented
}
