/* 
 * File   : Debug.h
 * Author : Koen Martens <koen.martens@tomtom.com>
 * Desc.  : Debug function define
 *
 * Copyright (C) 2004,2005 TomTom BV <http://www.tomtom.com/>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 */

#ifndef __DEBUG_H__
#define __DEBUG_H__

#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif


#ifdef DEBUG  

#ifdef A2DP_DEBUG_FILE  

#define A2DP_DEBUG_FILE_NAME "/mnt/sdcard/a2dp.log"

#define DBG(fmt, arg...) \
    { \
     FILE* tmpF = fopen( A2DP_DEBUG_FILE_NAME, "a+b" );\
     fprintf(stderr,"%s: " fmt , __FUNCTION__, ##arg);\
     if( NULL != tmpF )\
     {\
      fprintf( tmpF,"%s: " fmt , __FUNCTION__, ##arg);\
      fclose( tmpF );\
     }\
    }
#else
#define DBG(fmt, arg...)	fprintf(stderr,"%s: " fmt , __FUNCTION__, ##arg)
#endif
#else
  #define DBG(fmt, arg...)	do {} while(0)
#endif


#ifdef __cplusplus
}
#endif

#endif // __MAD_PRODUCER_H__
