/* 
 * File   : MadProducer.h
 * Author : Koen Martens <koen.martens@tomtom.com>
 * Desc.  : mp3 decoder macro's, datastructures and function prototypes
 *
 * Copyright (C) 2004,2005 TomTom BV <http://www.tomtom.com/>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 */

#ifndef __MAD_PRODUCER_H__
#define __MAD_PRODUCER_H__

#ifdef __cplusplus
extern "C" {
#endif

#include <limits.h>
#include <pthread.h>
#include <basetypes.h>

#include "mad.h"
#include "ReadFile.h"
#include "AudioPlugIn.h"

#define PUT_SAMPLE( chan, options, Synth, OutputPtr )  {						\
      			    if( options & MO_PCM ) {							\
			      if( options & MO_SWP ) {							\
          		    	Sample = MadFixedToSshort( Synth.pcm.samples[ chan ][ i ] );		\
                                *( OutputPtr++ ) = Sample & 0xff;					\
                                *( OutputPtr++ ) = Sample >> 8;						\
	                      } else {									\
                                Sample = MadFixedToSshort( Synth.pcm.samples[ chan ][ i ] );		\
          			*( OutputPtr++ ) = Sample >> 8;						\
          			*( OutputPtr++ ) = Sample & 0xff;					\
			      }										\
      			    } else {									\
   			      *( ( volatile mad_fixed_t* )OutputPtr ) = Synth.pcm.samples[ chan ][ i ];	\
			      OutputPtr += sizeof( mad_fixed_t );					\
      			    }										\
			  }


#define MAD_INTERNAL_INPUT_BUFFER_SIZE       (5*8192)

	// StreamBuffer thread function
void *MadDecoder( void *arg );

typedef struct {
  int                  options;
  StreamBufferHandle  *h;
  fileReaderData      *fileReader;
  volatile int         terminated;
  volatile unsigned int  bytesRead;
  volatile unsigned long timeStamp;
  volatile unsigned int  fileSize;
  volatile int         skip;
  volatile int         skipped;
  volatile int         paused;
  pthread_mutex_t      skipMutex;
  int                  haveAudioAccept;
  volatile int         discardAndWait; // 1=discard everything and wait for resumeCond;
  pthread_mutex_t      resumeMutex;
  pthread_cond_t       resumeCond;
} MadOpt;

#ifdef __cplusplus
}
#endif

#endif // __MAD_PRODUCER_H__
