
#ifndef __A2DP_PLUGIN_H__
#define __A2DP_PLUGIN_H__

#include "AudioPlugIn.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef enum { KNoPause, KSync, KDiscard, KPauseImmediately } EPauseMode;
;
// A2DP functions
int PlugInInit( audio_output_model_t aModel, void* aData );
int PlugInGetInputFormat( void );
int PlugInSetVolume( int aVolume );
int PlugInGetVolume( void );
int PlugInStartPlayback( int ( *aReadFunction )( void**ptr, int len ), char* aErrorText );
int PlugInPushData( void* aData, int aLength );
int PlugInStopPlayback( void );
int PlugInPausePlayback( EPauseMode aPauseMode, char* aErrorText );
int PlugInResumePlayback( char* aErrorText );
int PlugInGetPosition( void );
int PlugInDone( void );
int PlugInPlaybackFinished( int* aPlaybackInitialised, int* aPlaybackConnected );
int PlugInProcessPeerEvents( void ); 
    
#ifdef __cplusplus
}
#endif

#endif //__A2DP_PLUGIN_H__

