/* 
 * File   : TomTomProjects/AudioStreaming/StreamTest.c
 * Author : Koen Martens <koen.martens@tomtom.com>
 * Desc.  : Demo of mp3 decoder with synchronised output
 *
 * Copyright (C) 2004,2005 TomTom BV <http://www.tomtom.com/>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 */

#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include "StreamBuffer.h"
#include "MadProducer.h"

int main(int argc,char *argv[]) {
  int rv=0;
  int wrv;
  void *ptr;
  MadOpt opt;
  StreamBufferHandle *h;

  opt.fd=STDIN_FILENO;
  //opt.options=MO_MAD;
  opt.options=(MO_PCM | MO_NOSWP);
  //opt.options=(MO_PCM | MO_SWP);

  fprintf(stderr,"Initializing..\n");

  if( ! ( h=InitStreamBuffer(8192,MadDecoder,&opt,0) ) ) {
    fprintf(stderr,"unable to initialize\n");
    return 1;
  }

  fprintf(stderr,"Initialized..\n");

  do {
    rv=ReadStreamBuffer(h,&ptr,1024);
    if(rv) fprintf(stderr,"readbuffer=%i\n",rv);
    if(rv>0) {
      while(rv) {
        wrv=fwrite(ptr,1,(unsigned)rv,stdout);
	rv-=wrv;
        fprintf(stderr,"written %i bytes, %i left\n",wrv,rv);
      }
    } else if(rv==0) {
      //sleep(1);
    }
  } while(rv!=-1);

  return 0;
}

