/*
 A2DP lsitening functions 
*/

#ifndef __A2DP_LISTEN__
#define __A2DP_LISTEN__

#include <pthread.h>

#define EErrorNone         0
#define EErrorFailed      -1
#define EErrorInterrupted -2

typedef struct __a2dp_listen_t 
{
 int  iStopListen;    // Set by calling thread to 1 when it needs to abort listening
 int  iChannel;       // BT channel to listen to, set by caller
 char iBTAddr[ 100 ]; // BT address to listen to, set by caller, updated by listen function
                      // If strlen == 0, accept connect from any BT addr, if not - only accept
                      // from given one and refuse other connections and keep listening
                      // When connection is established, listen thread should put there address of actual remote device
 int  iFile;          // Open BT file descriptor, set by listening function
 void ( *RemoteConnected )( struct __a2dp_listen_t* aListenData ); // Call back should be called by listening func if a connection
                      // is accepted, and listen func should exit after this
 pthread_t  iThread;
 int        iResult;
 void*      iUserData;
} a2dp_listen_t;

// PHTREAD BT listen func, receives pointer to ListenStruct

int StartListen( a2dp_listen_t* aListenStruct ); 
void StopListen( a2dp_listen_t* aListenStruct ); 

void* ListenRemoteBTDevice( void* aListenStruct ); 

#endif // __A2DP_LISTEN__

