/*      
 * File   : Encoder.h
 * Author : Koen Martens <koen.martens@tomtom.com>
 * Desc.  : Datatypes and function prototypes
 *
 * Copyright (C) 2004,2005 TomTom BV <http://www.tomtom.com/>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 */

#ifndef __A2DPPLAYER_H__
#define __A2DPPLAYER_H__

#ifdef __cplusplus
extern "C" {
#endif

#include <pthread.h>
#include "Packager.h"
#include "StreamBuffer.h"

typedef struct {
  pthread_t	            thr;
  pthread_mutex_t       killMutex;
  pthread_mutex_t       eosMutex;
  pthread_cond_t        killCond;

  volatile int          killThread;
  volatile int          eos;

  packager_t           *packager;

  volatile unsigned long long currentPos; // Current position in microseconds  

  volatile unsigned int paused;
  volatile unsigned int resumed;
  volatile unsigned int sync;
} a2dp_player_t;

a2dp_player_t *InitA2dpPlayer(packager_t *p, char* aErrorText );
void DestroyA2dpPlayer(a2dp_player_t *h);


#ifdef __cplusplus
}
#endif

#endif //  __A2DPPLAYER_H__

/* EOF */
