# common-linux.mk
#
# Shared Makefile definitions for Linux.
#
# Copyright (C) 2006 TomTom BV. All rights reserved.
# Author 0: Dimitry Andric <dimitry.andric@tomtom.com>

# Default architecture
ARCH?=arm

ifeq ($(ARCH),x86)
TT_CROSS=
TT_DEFS=
TT_CPU=
else
TT_CROSS=$(ARCH)-linux-
TT_DEFS=-DSAMSUNG -DLINUX26
TT_CPU=-mcpu=arm920
endif

TT_CC=$(TT_CROSS)gcc
TT_CXX=$(TT_CROSS)g++
TT_LD=$(TT_CROSS)ld
TT_AR=$(TT_CROSS)ar
TT_STRIP=$(TT_CROSS)strip

TT_CPPFLAGS=-DLINUX_TARGET $(TT_DEFS)
TT_WARNFLAGS=-Wall -W -Wno-unused-parameter -Wno-unknown-pragmas
TT_CFLAGS=$(TT_CPU) -ffunction-sections -fdata-sections
TT_CXXFLAGS=$(TT_CFLAGS)
TT_LDFLAGS=-Wl,--gc-sections
TT_SOFLAGS=-shared

ifeq ($(DEBUG),y)
TT_CPPFLAGS+=-DDEBUG
TT_CFLAGS+=-O0 -g
TT_LDFLAGS+=-g
else
TT_CPPFLAGS+=-DNDEBUG
TT_CFLAGS+=-Os
TT_LDFLAGS+=-s
endif

# EOF
